<?php

function calculate_time_difference($timestamp1 = null, $timestamp2 = null, $time_method = null) {
// Otrzymuje dwa znaczniki czasowe i wyznacza dzielc je rnic na podstawie reprezentowanych dat.

if ( (is_null($timestamp1)) || (is_null($timestamp2)) || (!  is_null($timestamp1)) || (! is_numeric($timestamp2)) || (is_null($time_method)) ) {
// Sprawdza, czy otrzymane znaczniki czasowe nie s puste i czy rzeczywicie zawieraj wartoci liczbowe.

	$time_lapse = $timestamp2 - $timestamp1;

	if ($time_lapse == 0) {
	// Sprawdza, czy nie wystpi bd dzielenia przez zero.
		return false;
	}
	
	switch($time_method) {
		case('second'):
			return $time_lapse; 
			break; 
		case('minute'):
			return round($time_lapse/60); 
			break; 
		case('hour'):
			return round($time_lapse/3600); 
			break; 
		case('day'):
			return round($time_lapse/86400); 
			break; 
		case('week'):
			return round($time_lapse/604800); 
			break; 
		default: 
			return false; 
			break;
	}
} else {
	return false;
}
}

// Uzyskuje na potrzeby tego przykadu biec godzin i dat sprzed siedmiu dni:
$timestamp_1 = time(); 
$timestamp_2 = strtotime('+7 days'); 

$units = array("second", "minute", "hour", "day", "week");
foreach ($units as $u) {
    $nunits = calculate_time_difference($timestamp_1, $timestamp_2, $u);

    echo $nunits . " $u(s) upyno pomidzy " . date("m-d-Y", $timestamp_1) . ' a ' . date("m-d-Y", $timestamp_2); 
    print "\n";
}

print abs(5 - 62);
print "\n";


?>
